import ctypes
import time


def printSample(printer):
    dll.TSPL_Setup(printer, 4, 8, 63, 101, 1, 2, 4)
    dll.TSPL_ClearBuffer(printer)
    dll.TSPL_Direction(printer, 0, 0)
    dll.TSPL_Box(printer, 6, 6, 384, 235, 5, 1)
    dll.TSPL_Box(printer, 16, 16, 376, 225, 5, 1)
    dll.TSPL_BarCode(printer, 30, 30, 7, b"ABCDEFGH", 100, 0, 0, 2, 2)
    dll.TSPL_QrCode(printer, 265, 30, 4, 1, 0, 0, 1, 2, b"test qrcode")
    dll.TSPL_Text(printer, 200, 144, b"3", b"Test EN", 0, 1, 1, 0)
    dll.TSPL_Text(printer, 38, 165, b"3", b"Test EN", 0, 1, 2, 0)
    dll.TSPL_Bar(printer, 200, 183, 166, 30)
    dll.TSPL_Bar(printer, 334, 145, 30, 30)
    dll.TSPL_Print(printer, 1, 1)
    return


def printMenu():
    print("**************************************")
    print("*  1.Print Sample    0.Exit          *")
    print("**************************************")
    iRet = input("Please enter your selection:")
    if iRet == "0" or iRet == "1":
        return iRet
    print("Input err!")
    return printMenu


dll = ctypes.CDLL("printer.sdk.dll")
printer = ctypes.c_void_p()
ret = dll.PrinterCreator(ctypes.byref(printer), b"")
while True:
    iRet = printMenu()
    if iRet == "0":
        break
    ret = dll.PortOpen(printer, b"USB,")
    if ret == 0:
        print("Connect Success!")
        if iRet == "1":
            printSample(printer)
        time.sleep(1)
        dll.ClosePort(printer)
    else:
        print("Connect Fail!")
        break
dll.ReleasePrinter(printer)
print("Bye!")
